Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/XMP.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/XMP.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/XMP.pm	(revision 34921)
@@ -2305,90 +2775,115 @@
 #------------------------------------------------------------------------------
 # Generate flattened tags and add to table
-# Inputs: 0) tag table ref, 1) tag ID for Struct tag in table
+# Inputs: 0) tag table ref, 1) tag ID for Struct tag (if not defined, whole table is done),
+#         2) flag to not expand sub-structures
 # Returns: number of tags added (not counting those just initialized)
 # Notes: Must have verified that $$tagTablePtr{$tagID}{Struct} exists before calling this routine
 # - makes sure that the tagInfo Struct is a HASH reference
-sub AddFlattenedTags($$)
+sub AddFlattenedTags($;$$)
 {
     local $_;
-    my ($tagTablePtr, $tagID) = @_;
-    my $tagInfo = $$tagTablePtr{$tagID};
-
-    $$tagInfo{Flattened} and return 0;  # only generate flattened tags once
-    $$tagInfo{Flattened} = 1;
-
-    my $strTable = $$tagInfo{Struct};
-    unless (ref $strTable) { # (allow a structure name for backward compatibility only)
-        my $strName = $strTable;
-        $strTable = $Image::ExifTool::UserDefined::xmpStruct{$strTable} or return 0;
-        $$strTable{STRUCT_NAME} or $$strTable{STRUCT_NAME} = $strName;
-        $$tagInfo{Struct} = $strTable;  # replace old-style name with HASH ref
-        delete $$tagInfo{SubDirectory}; # deprecated use of SubDirectory in Struct tags
+    my ($tagTablePtr, $tagID, $noSubStruct) = @_;
+    my $count = 0;
+    my @tagIDs;
+
+    if (defined $tagID) {
+        push @tagIDs, $tagID;
+    } else {
+        foreach $tagID (TagTableKeys($tagTablePtr)) {
+            my $tagInfo = $$tagTablePtr{$tagID};
+            next unless ref $tagInfo eq 'HASH' and $$tagInfo{Struct};
+            push @tagIDs, $tagID;
+        }
     }
-    # do not add flattened tags to variable-namespace structures
-    return 0 if exists $$strTable{NAMESPACE} and not defined $$strTable{NAMESPACE};
-
-    # get family 2 group name for this structure tag
-    my ($tagG2, $field);
-    $tagG2 = $$tagInfo{Groups}{2} if $$tagInfo{Groups};
-    $tagG2 or $tagG2 = $$tagTablePtr{GROUPS}{2};
-
-    my $count = 0;
-    foreach $field (keys %$strTable) {
-        next if $specialStruct{$field};
-        my $fieldInfo = $$strTable{$field};
-        next if $$fieldInfo{LangCode};  # don't flatten lang-alt tags
-        # build a tag ID for the corresponding flattened tag
-        my $fieldName = ucfirst($field);
-        my $flatID = $tagID . $fieldName;
-        my $flatInfo = $$tagTablePtr{$flatID};
-        if ($flatInfo) {
-            ref $flatInfo eq 'HASH' or warn("$flatInfo is not a HASH!\n"), next; # (to be safe)
-            # pre-defined flattened tags should have Flat flag set
-            if (not defined $$flatInfo{Flat} and $Image::ExifTool::debug) {
-                warn "Missing Flat flag for $$flatInfo{Name}\n";
-            }
-            $$flatInfo{Flat} = 0;
-            # copy all missing entries from field information
-            foreach (keys %$fieldInfo) {
-                # must not copy PropertyPath (but can't delete it afterwards
-                # because the flat tag may already have this set)
-                next if $_ eq 'PropertyPath';
-                $$flatInfo{$_} = $$fieldInfo{$_} unless defined $$flatInfo{$_};
-            }
-            # NOTE: Do NOT delete Groups because we need them if GotGroups was done
-            # --> just override group 2 later according to field group
-            # re-generate List flag unless it is set to 0
-            delete $$flatInfo{List} if $$flatInfo{List};
-        } else {
-            # generate new flattened tag information based on structure field
-            $flatInfo = { %$fieldInfo, Name => $$tagInfo{Name} . $fieldName, Flat => 0 };
-            # add new flattened tag to table
-            Image::ExifTool::AddTagToTable($tagTablePtr, $flatID, $flatInfo);
-            ++$count;
-        }
-        # propagate List flag (unless set to 0 in pre-defined flattened tag)
-        unless (defined $$flatInfo{List}) {
-            $$flatInfo{List} = $$fieldInfo{List} || 1 if $$fieldInfo{List} or $$tagInfo{List};
-        }
-        # set group 2 name from the first existing family 2 group in the:
-        # 1) structure field Groups, 2) structure table GROUPS, 3) structure tag Groups
-        if ($$fieldInfo{Groups} and $$fieldInfo{Groups}{2}) {
-            $$flatInfo{Groups}{2} = $$fieldInfo{Groups}{2};
-        } elsif ($$strTable{GROUPS} and $$strTable{GROUPS}{2}) {
-            $$flatInfo{Groups}{2} = $$strTable{GROUPS}{2};
-        } else {
-            $$flatInfo{Groups}{2} = $tagG2;
-        }
-        # save reference to top-level structure
-        $$flatInfo{RootTagInfo} = $$tagInfo{RootTagInfo} || $tagInfo;
-        # recursively generate flattened tags for sub-structures
-        next unless $$flatInfo{Struct};
-        length($flatID) > 150 and warn("Possible deep recursion for tag $flatID\n"), last;
-        # reset flattened tag just in case we flattened hierarchy in the wrong order
-        # because we must start from the outtermost structure to get the List flags right
-        # (this should only happen when building tag tables)
-        delete $$flatInfo{Flattened};
-        $count += AddFlattenedTags($tagTablePtr, $flatID);
+
+    # loop through specified tags
+    foreach $tagID (@tagIDs) {
+
+        my $tagInfo = $$tagTablePtr{$tagID};
+
+        $$tagInfo{Flattened} and next;  # only generate flattened tags once
+        $$tagInfo{Flattened} = 1;
+
+        my $strTable = $$tagInfo{Struct};
+        unless (ref $strTable) { # (allow a structure name for backward compatibility only)
+            my $strName = $strTable;
+            $strTable = $Image::ExifTool::UserDefined::xmpStruct{$strTable} or next;
+            $$strTable{STRUCT_NAME} or $$strTable{STRUCT_NAME} = "XMP $strName";
+            $$tagInfo{Struct} = $strTable;  # replace old-style name with HASH ref
+            delete $$tagInfo{SubDirectory}; # deprecated use of SubDirectory in Struct tags
+        }
+
+        # get prefix for flattened tag names
+        my $flat = (defined $$tagInfo{FlatName} ? $$tagInfo{FlatName} : $$tagInfo{Name});
+
+        # get family 2 group name for this structure tag
+        my ($tagG2, $field);
+        $tagG2 = $$tagInfo{Groups}{2} if $$tagInfo{Groups};
+        $tagG2 or $tagG2 = $$tagTablePtr{GROUPS}{2};
+
+        foreach $field (keys %$strTable) {
+            next if $specialStruct{$field};
+            my $fieldInfo = $$strTable{$field};
+            next if $$fieldInfo{LangCode};  # don't flatten lang-alt tags
+            next if $$fieldInfo{Struct} and $noSubStruct;   # don't expand sub-structures if specified
+            # build a tag ID for the corresponding flattened tag
+            my $fieldName = ucfirst($field);
+            my $flatField = $$fieldInfo{FlatName} || $fieldName;
+            my $flatID = $tagID . $fieldName;
+            my $flatInfo = $$tagTablePtr{$flatID};
+            if ($flatInfo) {
+                ref $flatInfo eq 'HASH' or warn("$flatInfo is not a HASH!\n"), next; # (to be safe)
+                # pre-defined flattened tags should have Flat flag set
+                if (not defined $$flatInfo{Flat}) {
+                    next if $$flatInfo{NotFlat};
+                    warn "Missing Flat flag for $$flatInfo{Name}\n" if $Image::ExifTool::debug;
+                }
+                $$flatInfo{Flat} = 0;
+                # copy all missing entries from field information
+                foreach (keys %$fieldInfo) {
+                    # must not copy PropertyPath (but can't delete it afterwards
+                    # because the flat tag may already have this set)
+                    next if $_ eq 'PropertyPath' or defined $$flatInfo{$_};
+                    # copy the property (making a copy of the Groups hash)
+                    $$flatInfo{$_} = $_ eq 'Groups' ? { %{$$fieldInfo{$_}} } : $$fieldInfo{$_};
+                }
+                # (NOTE: Can NOT delete Groups because we need them if GotGroups was done)
+                # re-generate List flag unless it is set to 0
+                delete $$flatInfo{List} if $$flatInfo{List};
+            } else {
+                # generate new flattened tag information based on structure field
+                my $flatName = $flat . $flatField;
+                $flatInfo = { %$fieldInfo, Name => $flatName, Flat => 0 };
+                $$flatInfo{FlatName} = $flatName if $$fieldInfo{FlatName};
+                # make a copy of the Groups hash if necessary
+                $$flatInfo{Groups} = { %{$$fieldInfo{Groups}} } if $$fieldInfo{Groups};
+                # add new flattened tag to table
+                AddTagToTable($tagTablePtr, $flatID, $flatInfo);
+                ++$count;
+            }
+            # propagate List flag (unless set to 0 in pre-defined flattened tag)
+            unless (defined $$flatInfo{List}) {
+                $$flatInfo{List} = $$fieldInfo{List} || 1 if $$fieldInfo{List} or $$tagInfo{List};
+            }
+            # set group 2 name from the first existing family 2 group in the:
+            # 1) structure field Groups, 2) structure table GROUPS, 3) structure tag Groups
+            if ($$fieldInfo{Groups} and $$fieldInfo{Groups}{2}) {
+                $$flatInfo{Groups}{2} = $$fieldInfo{Groups}{2};
+            } elsif ($$strTable{GROUPS} and $$strTable{GROUPS}{2}) {
+                $$flatInfo{Groups}{2} = $$strTable{GROUPS}{2};
+            } else {
+                $$flatInfo{Groups}{2} = $tagG2;
+            }
+            # save reference to top-level structure
+            $$flatInfo{RootTagInfo} = $$tagInfo{RootTagInfo} || $tagInfo;
+            # recursively generate flattened tags for sub-structures
+            next unless $$flatInfo{Struct};
+            length($flatID) > 250 and warn("Possible deep recursion for tag $flatID\n"), last;
+            # reset flattened tag just in case we flattened hierarchy in the wrong order
+            # because we must start from the outtermost structure to get the List flags right
+            # (this should only happen when building tag tables)
+            delete $$flatInfo{Flattened};
+            $count += AddFlattenedTags($tagTablePtr, $flatID, $$flatInfo{NoSubStruct});
+        }
     }
     return $count;
@@ -2397,5 +2892,5 @@
 #------------------------------------------------------------------------------
 # Get localized version of tagInfo hash
-# Inputs: 0) tagInfo hash ref, 1) language code (ie. "x-default")
+# Inputs: 0) tagInfo hash ref, 1) language code (eg. "x-default")
 # Returns: new tagInfo hash ref, or undef if invalid
 sub GetLangInfo($$)
@@ -2406,6 +2901,4 @@
     $langCode =~ tr/_/-/;   # RFC 3066 specifies '-' as a separator
     my $langInfo = Image::ExifTool::GetLangInfo($tagInfo, $langCode);
-    # save reference to source tagInfo hash in case we need to set the PropertyPath later
-    $$langInfo{SrcTagInfo} = $tagInfo;
     return $langInfo;
 }
@@ -2430,9 +2923,9 @@
 sub ScanForXMP($$)
 {
-    my ($exifTool, $raf) = @_;
+    my ($et, $raf) = @_;
     my ($buff, $xmp);
     my $lastBuff = '';
 
-    $exifTool->VPrint(0,"Scanning for XMP\n");
+    $et->VPrint(0,"Scanning for XMP\n");
     for (;;) {
         defined $buff or $raf->Read($buff, 65536) or return 0;
@@ -2462,15 +2955,95 @@
         }
     }
-    unless ($exifTool->{VALUE}{FileType}) {
-        $exifTool->{FILE_TYPE} = $exifTool->{FILE_EXT};
-        $exifTool->SetFileType('<unknown file containing XMP>');
+    unless ($$et{VALUE}{FileType}) {
+        $$et{FILE_TYPE} = $$et{FILE_EXT};
+        $et->SetFileType('<unknown file containing XMP>', undef, '');
     }
     my %dirInfo = (
-        DataPt => \$xmp,
-        DirLen => length $xmp,
+        DataPt  => \$xmp,
+        DirLen  => length $xmp,
         DataLen => length $xmp,
     );
-    ProcessXMP($exifTool, \%dirInfo);
+    ProcessXMP($et, \%dirInfo);
     return 1;
+}
+
+#------------------------------------------------------------------------------
+# Print conversion for XMP-aux:LensID
+# Inputs: 0) ExifTool ref, 1) LensID, 2) Make, 3) LensInfo, 4) FocalLength,
+#         5) LensModel, 6) MaxApertureValue
+# (yes, this is ugly -- blame Adobe)
+sub PrintLensID(@)
+{
+    local $_;
+    my ($et, $id, $make, $info, $focalLength, $lensModel, $maxAv) = @_;
+    my ($mk, $printConv);
+    my %alt = ( Pentax => 'Ricoh' );    # Pentax changed its name to Ricoh
+    # missing: Olympus (no XMP:LensID written by Adobe)
+    foreach $mk (qw(Canon Nikon Pentax Sony Sigma Samsung Leica)) {
+        next unless $make =~ /$mk/i or ($alt{$mk} and $make =~ /$alt{$mk}/i);
+        # get name of module containing the lens lookup (default "Make.pm")
+        my $mod = { Sigma => 'SigmaRaw', Leica => 'Panasonic' }->{$mk} || $mk;
+        require "Image/ExifTool/$mod.pm";
+        # get the name of the lens name lookup (default "makeLensTypes")
+        # (canonLensTypes, pentaxLensTypes, nikonLensIDs, etc)
+        my $convName = "Image::ExifTool::${mod}::" .
+            ({ Nikon => 'nikonLensIDs' }->{$mk} || lc($mk) . 'LensTypes');
+        no strict 'refs';
+        %$convName or last;
+        my $printConv = \%$convName;
+        use strict 'refs';
+        # sf = short focal
+        # lf = long focal
+        # sa = max aperture at short focal
+        # la = max aperture at long focal
+        my ($sf, $lf, $sa, $la);
+        if ($info) {
+            my @a = split ' ', $info;
+            $_ eq 'undef' and $_ = undef foreach @a;
+            ($sf, $lf, $sa, $la) = @a;
+            # for Sony and ambiguous LensID, $info data may be incorrect:
+            # use only if it agrees with $focalLength and $maxAv (ref JR)
+            if ($mk eq 'Sony' and
+                (($focalLength and (($sf and $focalLength < $sf - 0.5) or
+                                    ($lf and $focalLength > $lf + 0.5))) or
+                 ($maxAv and (($sa and $maxAv < $sa - 0.15) or
+                              ($la and $maxAv > $la + 0.15)))))
+            {
+                undef $sf;
+                undef $lf;
+                undef $sa;
+                undef $la;
+            } elsif ($maxAv) {
+                # (using the short-focal-length max aperture in place of MaxAperture
+                # is a bad approximation, so don't do this if MaxApertureValue exists)
+                undef $sa;
+            }
+        }
+        if ($mk eq 'Pentax' and $id =~ /^\d+$/) {
+            # for Pentax, CS4 stores an int16u, but we use 2 x int8u
+            $id = join(' ', unpack('C*', pack('n', $id)));
+        }
+        # Nikon is a special case because Adobe doesn't store the full LensID
+        # (Apple Photos does, but we have to convert back to hex)
+        if ($mk eq 'Nikon') {
+            $id = sprintf('%X', $id);
+            $id = "0$id" if length($id) & 0x01;     # pad with leading 0 if necessary
+            $id =~ s/(..)/$1 /g and $id =~ s/ $//;  # put spaces between bytes
+            my (%newConv, %used);
+            my $i = 0;
+            foreach (grep /^$id/, keys %$printConv) {
+                my $lens = $$printConv{$_};
+                next if $used{$lens}; # avoid duplicates
+                $used{$lens} = 1;
+                $newConv{$i ? "$id.$i" : $id} = $lens;
+                ++$i;
+            }
+            $printConv = \%newConv;
+        }
+        my $str = $$printConv{$id} || "Unknown ($id)";
+        return Image::ExifTool::Exif::PrintLensID($et, $str, $printConv,
+                    undef, $id, $focalLength, $sa, $maxAv, $sf, $lf, $lensModel);
+    }
+    return "Unknown ($id)";
 }
 
@@ -2499,5 +3072,5 @@
     my $val = $_[0];
     $val =~ m{^(-?\d+)/(-?\d+)$} or return undef;
-    if ($2) {
+    if ($2 != 0) {
         $_[0] = $1 / $2; # calculate quotient
     } elsif ($1) {
@@ -2507,4 +3080,19 @@
     }
     return 1;
+}
+
+#------------------------------------------------------------------------------
+# Convert a string of floating point values to rationals
+# Inputs: 0) string of floating point numbers separated by spaces
+# Returns: string of rational numbers separated by spaces
+sub ConvertRationalList($)
+{
+    my $val = shift;
+    my @vals = split ' ', $val;
+    return $val unless @vals == 4;
+    foreach (@vals) {
+        ConvertRational($_) or return $val;
+    }
+    return join ' ', @vals;
 }
 
@@ -2518,15 +3106,15 @@
 {
     local $_;
-    my ($exifTool, $tagTablePtr, $props, $val, $attrs) = @_;
-    my ($lang, @structProps);
-    my ($tag, $ns) = GetXMPTagID($props, $exifTool->{OPTIONS}{Struct} ? \@structProps : undef);
+    my ($et, $tagTablePtr, $props, $val, $attrs) = @_;
+    my ($lang, @structProps, $rawVal, $rational);
+    my ($tag, $ns) = GetXMPTagID($props, $$et{OPTIONS}{Struct} ? \@structProps : undef);
     return 0 unless $tag;   # ignore things that aren't valid tags
 
     # translate namespace if necessary
-    $ns = $$xlatNamespace{$ns} if $$xlatNamespace{$ns};
-    my $info = $tagTablePtr->{$ns};
+    $ns = $stdXlatNS{$ns} if $stdXlatNS{$ns};
+    my $info = $$tagTablePtr{$ns};
     my ($table, $added, $xns, $tagID);
     if ($info) {
-        $table = $info->{SubDirectory}{TagTable} or warn "Missing TagTable for $tag!\n";
+        $table = $$info{SubDirectory}{TagTable} or warn "Missing TagTable for $tag!\n";
     } elsif ($$props[0] eq 'svg:svg') {
         if (not $ns) {
@@ -2541,17 +3129,39 @@
     }
 
-    # look up this tag in the appropriate table
-    $table or $table = 'Image::ExifTool::XMP::other';
-    $tagTablePtr = GetTagTable($table);
-    if ($$tagTablePtr{NAMESPACE}) {
+    my $xmlGroups;
+    my $grp0 = $$tagTablePtr{GROUPS}{0};
+    if (not $ns and $grp0 ne 'XMP') {
         $tagID = $tag;
+    } elsif ($grp0 eq 'XML' and not $table) {
+        # this is an XML table (no namespace lookup)
+        $tagID = "$ns:$tag";
     } else {
-        # add XMP namespace prefix to avoid collisions in variable-namespace tables
-        $xns = $xmpNS{$ns} || $ns;
-        $tagID = "$xns:$tag";
-        # add namespace to top-level structure property
-        $structProps[0][0] = "$xns:" . $structProps[0][0] if @structProps;
+        $xmlGroups = 1 if $grp0 eq 'XML';
+        # look up this tag in the appropriate table
+        $table or $table = 'Image::ExifTool::XMP::other';
+        $tagTablePtr = GetTagTable($table);
+        if ($$tagTablePtr{NAMESPACE}) {
+            $tagID = $tag;
+        } else {
+            $xns = $xmpNS{$ns};
+            unless (defined $xns) {
+                $xns = $ns;
+                # validate namespace prefix
+                unless ($ns =~ /^[A-Z_a-z\x80-\xff][-.0-9A-Z_a-z\x80-\xff]*$/ or $ns eq '') {
+                    $et->Warn("Invalid XMP namespace prefix '${ns}'");
+                    # clean up prefix for use as an ExifTool group name
+                    $ns =~ tr/-.0-9A-Z_a-z\x80-\xff//dc;
+                    $ns =~ /^[A-Z_a-z\x80-\xff]/ or $ns = "ns_$ns";
+                    $stdXlatNS{$xns} = $ns;
+                    $xmpNS{$ns} = $xns;
+                }
+            }
+            # add XMP namespace prefix to avoid collisions in variable-namespace tables
+            $tagID = "$xns:$tag";
+            # add namespace to top-level structure property
+            $structProps[0][0] = "$xns:" . $structProps[0][0] if @structProps;
+        }
     }
-    my $tagInfo = $exifTool->GetTagInfo($tagTablePtr, $tagID);
+    my $tagInfo = $et->GetTagInfo($tagTablePtr, $tagID);
 
     $lang = $$attrs{'xml:lang'} if $attrs;
@@ -2573,12 +3183,4 @@
             next unless ref $ti eq 'HASH' and $$ti{Struct};
             $addedFlat = AddFlattenedTags($tagTablePtr, $t);
-            if ($tagInfo) {
-                # all done if we just wanted to initialize the flattened tag
-                if ($$tagInfo{Flat}) {
-                    warn "Orphan tagInfo with Flat flag set: $$tagInfo{Name}\n";
-                    delete $$tagInfo{Flat};
-                }
-                last NoLoop;
-            }
             # all done if we generated the tag we are looking for
             $tagInfo = $$tagTablePtr{$tagID} and last NoLoop if $addedFlat;
@@ -2597,5 +3199,6 @@
                 next unless ref $ti eq 'HASH';
                 my $strTable = $$ti{Struct} or next;
-                $name = $$ti{Name} . ucfirst($t2);
+                my $flat = (defined $$ti{FlatName} ? $$ti{FlatName} : $$ti{Name});
+                $name = $flat . ucfirst($t2);
                 # don't continue if structure is known but field is not
                 last if $$strTable{NAMESPACE} or not exists $$strTable{NAMESPACE};
@@ -2605,5 +3208,5 @@
                 my $n = $nsList[$i+1];  # namespace of structure field
                 # translate to standard ExifTool namespace
-                $n = $$xlatNamespace{$n} if $$xlatNamespace{$n};
+                $n = $stdXlatNS{$n} if $stdXlatNS{$n};
                 my $xn = $xmpNS{$n} || $n;  # standard XMP namespace
                 # no need to continue with variable-namespace logic if
@@ -2620,9 +3223,9 @@
                 last unless ref $tg eq 'HASH' and $$tg{SubDirectory};
                 my $tbl = GetTagTable($$tg{SubDirectory}{TagTable}) or last;
-                my $sti = $exifTool->GetTagInfo($tbl, $t2);
+                my $sti = $et->GetTagInfo($tbl, $t2);
                 if (not $sti or $$sti{Flat}) {
                     # again, we must initialize flattened tags if necessary
                     # (but don't bother to recursively apply full logic to
-                    #  allow nest variable-namespace strucures until someone
+                    #  allow nested variable-namespace strucures until someone
                     #  actually wants to do such a silly thing)
                     my $t3 = '';
@@ -2637,9 +3240,6 @@
                     last unless $sti;
                 }
-                $tagInfo = {
-                    %$sti,
-                    Name     => $$ti{Name} . $$sti{Name},
-                    WasAdded => 1,
-                };
+                # generate new tagInfo hash based on existing top-level tag
+                $tagInfo = { %$sti, Name => $flat . $$sti{Name} };
                 # be careful not to copy elements we shouldn't...
                 delete $$tagInfo{Description}; # Description will be different
@@ -2651,9 +3251,10 @@
             }
         }
-        $tagInfo or $tagInfo = { Name => $name, WasAdded => 1 };
+        # generate a default tagInfo hash if necessary
+        $tagInfo or $tagInfo = { Name => $name, IsDefault => 1, Priority => 0 };
 
         # add tag Namespace entry for tags in variable-namespace tables
         $$tagInfo{Namespace} = $xns if $xns;
-        if ($curNS{$ns} and $curNS{$ns} =~ m{^http://ns.exiftool.ca/(.*?)/(.*?)/}) {
+        if ($$et{curURI}{$ns} and $$et{curURI}{$ns} =~ m{^http://ns.exiftool.(?:ca|org)/(.*?)/(.*?)/}) {
             my %grps = ( 0 => $1, 1 => $2 );
             # apply a little magic to recover original group names
@@ -2683,6 +3284,7 @@
         #    $$tagInfo{List} = 1;
         }
-        Image::ExifTool::AddTagToTable($tagTablePtr, $tagID, $tagInfo);
-        $added = 1;
+        # save property list for verbose "adding" message unless this tag already exists
+        $added = \@tagList unless $$tagTablePtr{$tagID};
+        AddTagToTable($tagTablePtr, $tagID, $tagInfo);
         last;
     }
@@ -2717,31 +3319,74 @@
     }
     # decode from UTF8
-    $val = $exifTool->Decode($val, 'UTF8');
+    $val = $et->Decode($val, 'UTF8');
     # convert rational and date values to a more sensible format
     my $fmt = $$tagInfo{Writable};
-    my $new = $$tagInfo{WasAdded};
-    if (($fmt or $new)) {
-        unless (($new or $fmt eq 'rational') and ConvertRational($val)) {
+    my $new = $$tagInfo{IsDefault} && $$et{OPTIONS}{XMPAutoConv};
+    if ($fmt or $new) {
+        $rawVal = $val; # save raw value for verbose output
+        if (($new or $fmt eq 'rational') and ConvertRational($val)) {
+            $rational = $rawVal;
+        } else {
             $val = ConvertXMPDate($val, $new) if $new or $fmt eq 'date';
         }
+        if ($$et{XmpValidate} and $fmt and $fmt eq 'boolean') {
+            $et->WarnOnce("Boolean value for XMP-$ns:$$tagInfo{Name} should be capitalized",1);
+        }
+        # protect against large binary data in unknown tags
+        $$tagInfo{Binary} = 1 if $new and length($val) > 65536;
     }
     # store the value for this tag
-    my $key = $exifTool->FoundTag($tagInfo, $val);
+    my $key = $et->FoundTag($tagInfo, $val) or return 0;
+    # save original components of rational numbers (used when copying)
+    $$et{RATIONAL}{$key} = $rational if defined $rational;
+    # allow read-only subdirectories (eg. embedded base64 XMP/IPTC in NKSC files)
+    if ($$tagInfo{SubDirectory} and not $$et{IsWriting}) {
+        my $subdir = $$tagInfo{SubDirectory};
+        my $dataPt = ref $$et{VALUE}{$key} ? $$et{VALUE}{$key} : \$$et{VALUE}{$key};
+        # process subdirectory information
+        my %dirInfo = (
+            DirName  => $$subdir{DirName} || $$tagInfo{Name},
+            DataPt   => $dataPt,
+            DirLen   => length $$dataPt,
+            IsExtended => 1, # (hack to avoid Duplicate warning for embedded XMP)
+        );
+        my $oldOrder = GetByteOrder();
+        SetByteOrder($$subdir{ByteOrder}) if $$subdir{ByteOrder};
+        my $oldNS = $$et{definedNS};
+        delete $$et{definedNS};
+        my $subTablePtr = GetTagTable($$subdir{TagTable}) || $tagTablePtr;
+        $et->ProcessDirectory(\%dirInfo, $subTablePtr, $$subdir{ProcessProc});
+        SetByteOrder($oldOrder);
+        $$et{definedNS} = $oldNS;
+    }
     # save structure/list information if necessary
-    if (@structProps and (@structProps > 1 or defined $structProps[0][1])) {
-        $exifTool->{TAG_EXTRA}{$key}{Struct} = \@structProps;
-        $exifTool->{IsStruct} = 1;
+    if (@structProps and (@structProps > 1 or defined $structProps[0][1]) and
+        not $$et{NO_STRUCT})
+    {
+        $$et{TAG_EXTRA}{$key}{Struct} = \@structProps;
+        $$et{IsStruct} = 1;
     }
-    if ($ns and not $$tagInfo{StaticGroup1}) {
+    if ($xmlGroups) {
+        $et->SetGroup($key, 'XML', 0);
+        $et->SetGroup($key, "XML-$ns", 1);
+    } elsif ($ns and not $$tagInfo{StaticGroup1}) {
         # set group1 dynamically according to the namespace
-        $exifTool->SetGroup($key, "$tagTablePtr->{GROUPS}{0}-$ns");
+        $et->SetGroup($key, "$$tagTablePtr{GROUPS}{0}-$ns");
     }
-    if ($exifTool->{OPTIONS}{Verbose}) {
+    if ($$et{OPTIONS}{Verbose}) {
         if ($added) {
-            my $g1 = $exifTool->GetGroup($key, 1);
-            $exifTool->VPrint(0, $exifTool->{INDENT}, "[adding $g1:$tag]\n");
+            my $props;
+            if (@$added > 1) {
+                $$tagInfo{Flat} = 0;    # this is a flattened tag
+                my @props = map { $$_[0] } @$added;
+                $props = ' (' . join('/',@props) . ')';
+            } else {
+                $props = '';
+            }
+            my $g1 = $et->GetGroup($key, 1);
+            $et->VPrint(0, $$et{INDENT}, "[adding $g1:$tag]$props\n");
         }
         my $tagID = join('/',@$props);
-        $exifTool->VerboseInfo($tagID, $tagInfo, Value=>$val);
+        $et->VerboseInfo($tagID, $tagInfo, Value => $rawVal || $val);
     }
     return 1;
@@ -2750,28 +3395,30 @@
 #------------------------------------------------------------------------------
 # Recursively parse nested XMP data element
-# Inputs: 0) ExifTool object reference
-#         1) Pointer to tag table
-#         2) reference to XMP data
-#         3) start of xmp element
-#         4) reference to array of enclosing XMP property names (undef if none)
-#         5) reference to blank node information hash
+# Inputs: 0) ExifTool ref, 1) tag table ref, 2) XMP data ref
+#         3) offset to start of XMP element, 4) offset to end of XMP element
+#         5) reference to array of enclosing XMP property names (undef if none)
+#         6) reference to blank node information hash
 # Returns: Number of contained XMP elements
-sub ParseXMPElement($$$;$$$)
+sub ParseXMPElement($$$;$$$$)
 {
-    my ($exifTool, $tagTablePtr, $dataPt, $start, $propListPt, $blankInfo) = @_;
+    local $_;
+    my ($et, $tagTablePtr, $dataPt, $start, $end, $propList, $blankInfo) = @_;
     my ($count, $nItems) = (0, 0);
-    my $isWriting = $exifTool->{XMP_CAPTURE};
-    my $isSVG = $$exifTool{XMP_IS_SVG};
+    my $isWriting = $$et{XMP_CAPTURE};
+    my $isSVG = $$et{XMP_IS_SVG};
+    my $saveNS;     # save xlatNS lookup if changed for the scope of this element
+    my (%definedNS, %usedNS);  # namespaces defined and used in this scope
 
     # get our parse procs
     my ($attrProc, $foundProc);
-    if ($$exifTool{XMPParseOpts}) {
-        $attrProc = $$exifTool{XMPParseOpts}{AttrProc};
-        $foundProc = $$exifTool{XMPParseOpts}{FoundProc} || \&FoundXMP;
+    if ($$et{XMPParseOpts}) {
+        $attrProc = $$et{XMPParseOpts}{AttrProc};
+        $foundProc = $$et{XMPParseOpts}{FoundProc} || \&FoundXMP;
     } else {
         $foundProc = \&FoundXMP;
     }
     $start or $start = 0;
-    $propListPt or $propListPt = [ ];
+    $end or $end = length $$dataPt;
+    $propList or $propList = [ ];
 
     my $processBlankInfo;
